import abc
from . import StorageError as StorageError, base as base
from ..core.base import ExecutorEntity as ExecutorEntity, LoggingEntity as LoggingEntity
from ..core.formatter import FormattedEntity as FormattedEntity
from ..http import URL as URL
from ..net.web.client import Session as Session
from abc import abstractmethod
from typing import Any

class StorageConnectionError(StorageError): ...
class StorageDataFormatError(StorageError): ...

class AbstractHttpStorage(FormattedEntity, LoggingEntity, base.AbstractStorageReadOnly, metaclass=abc.ABCMeta):
    session: Any = ...
    def __init__(self, *args: Any, **kwargs: Any) -> None: ...
    session_params: Any = ...
    async def init(self) -> None: ...
    @abstractmethod
    async def session_factory(self, **kwargs: Any) -> Any: ...
    async def reset_session(self, **kwargs: Any) -> None: ...
    async def stop(self) -> None: ...
    def raw_key(self, key: Any): ...
    async def request(self, url: Any, **kwargs: Any): ...
    def get(self, key: Any): ...
    async def copy(self, key_source: Any, storage_dest: Any, key_dest: Any): ...

class RoStorage(ExecutorEntity, AbstractHttpStorage):
    def set_config(self, config: Any) -> None: ...
    async def session_factory(self, **kwargs: Any): ...
    async def request(self, url: Any, **kwargs: Any): ...

class Storage(RoStorage, base.AbstractStorageWriteOnly):
    def set(self, key: Any, value: Any): ...
